unit UDrawCell;

//=========================================================================
//
// I N T E R F A C E
//
//=========================================================================
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Grids, DBGrids, DB, DBClient, Provider, ExtCtrls,
  DBCtrls, StdCtrls;

type
  TFormDrawCell = class(TForm)
    DSProvider: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    StatusBar1: TStatusBar;
    ClientDataSet1EmpNo: TFloatField;
    ClientDataSet1LastName: TStringField;
    ClientDataSet1FirstName: TStringField;
    ClientDataSet1Precent: TFloatField;
    ClientDataSet1HireDate: TStringField;
    Panel1: TPanel;
    Label1: TLabel;
    cbdraw: TCheckBox;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    procedure StatusBar1Click(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure cbdrawClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

// constantes varias
const
  STR_EMPTY = '';
  CHAR_PERCENT = '%';
  SPACE_TO_CENTER_CELLTEXT = 0;

var
  FormDrawCell: TFormDrawCell;

//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================

implementation

{$R *.dfm}

uses
  ShellAPI;


procedure TFormDrawCell.StatusBar1Click(Sender: TObject);
begin
  ShellExecute(Handle,
         'open',
         'http://neftali.clubdelphi.com',
         nil,
         nil,
         SW_SHOW);
end;


procedure TFormDrawCell.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  fValue: Integer;
  ActualPenColor, ActualBrushColor: TColor;
  EmptyDS: Boolean;
  DrawRect: TRect;
  fWidth1, fLeft2: Integer;
  StrValue: string;
begin

  // No es la columna de porcentage?
  if not (Column.FieldName = 'Precent') then begin
    Exit;
  end;

  // No est la celda marcada?
  if not (cbdraw.Checked) then begin
    Exit;
  end;

  // Vaco?
  EmptyDS := ((TDBGrid(Sender).DataSource.DataSet.EoF) and
              (TDBGrid(Sender).DataSource.DataSet.Bof));

  // Columna nula?
  if (Column.Field.IsNull) then begin
    fValue := -1;
    StrValue := STR_EMPTY;
  end
  else begin
    fValue := Column.Field.AsInteger;
    StrValue := IntToStr(fValue) + CHAR_PERCENT;
  end;

  // Calcular el Rectngulo
  DrawRect := Rect;
  InflateRect(DrawRect, -1, -1);

  fWidth1 := (((DrawRect.Right - DrawRect.Left) * fValue) DIV 100);

  // Guardamos el color actual
  ActualPenColor := TDBGrid(Sender).Canvas.Pen.Color;
  ActualBrushColor := TDBGrid(Sender).Canvas.Brush.Color;
  // Definir el color de pintado
  TDBGrid(Sender).Canvas.Pen.Color := clHighlight;
  TDBGrid(Sender).Canvas.Brush.Color := clWhite;
  // Dibuja el recuadro exterior
  TDBGrid(Sender).Canvas.Rectangle(DrawRect);

  // Es diferente de 0 y de -1(null)?
  if (fValue > 0) then begin
    // Dibuja la parte que llevamos completada (porcentage)
    TDBGrid(Sender).Canvas.Pen.Color := clSkyBlue;
    TDBGrid(Sender).Canvas.Brush.Color := clSkyBlue;
    // rectngulo del porcentaje
    DrawRect.Right := DrawRect.Left + fWidth1;
    InflateRect(DrawRect, -1, -1);
    TDBGrid(Sender).Canvas.Rectangle(DrawRect);
  end;

  // Se debe pintar?
  if not (EmptyDS) then begin
    // porcentaje
    DrawRect := Rect;
    InflateRect(DrawRect, -2, -2);
    TDBGrid(Sender).Canvas.Brush.Style := bsClear;
    fLeft2 := DrawRect.Left + (DrawRect.Right - DrawRect.Left) shr 1 -
              (TDBGrid(Sender).Canvas.TextWidth(StrValue) shr 1);
    // Pintar el texto
    TDBGrid(Sender).Canvas.TextRect(DrawRect, fLeft2,
                                    DrawRect.Top + SPACE_TO_CENTER_CELLTEXT, StrValue);
  end;

  // Retaurar
  TDBGrid(Sender).Canvas.Pen.Color := ActualPenColor;
  TDBGrid(Sender).Canvas.Brush.Color := ActualBrushColor;

end;

procedure TFormDrawCell.cbdrawClick(Sender: TObject);
begin
  // repintar
  DBGrid1.Invalidate;
end;

end.
